### Hierarchy

- Noel

## Index

### Constructors

- constructor

### Properties

- eventsMap
- logger
- noEventListenersWarning
- replayBufferSize
- replayEnabled

### Methods

- clearEventsReplayBuffers
- clearReplayBufferForEvent
- disableEventsReplay
- disableNoEventListenersWarning
- disableReplay
- emit
- enableEventsReplay
- enableNoEventListenersWarning
- enableReplay
- getEvent
- getEvents
- getEventsMap
- makeEvent
- on
- removeAllListeners
- removeEvent
- removeEventListener
- removeListener
- replayIsEnabled
- setEventsReplayBuffersSize
- setLogger
- setReplayBufferSize

## Constructors

### constructor

- new Noel(config?: NoelConfig): Noel

- - Defined in noel.ts:22

  #### Parameters

  - ##### Optional config: NoelConfig

  #### Returns Noel

## Properties

### Private eventsMap

eventsMap: Map<string, NoelEvent> | null = null

- Defined in noel.ts:17

### Private logger

logger: NoelLogger

- Defined in noel.ts:19

### Private noEventListenersWarning

noEventListenersWarning: boolean

- Defined in noel.ts:15

### Private replayBufferSize

replayBufferSize: number

- Defined in noel.ts:22

### Private replayEnabled

replayEnabled: boolean

- Defined in noel.ts:21

## Methods

### clearEventsReplayBuffers

- clearEventsReplayBuffers(): void

- - Defined in noel.ts:115

  #### Returns void

### clearReplayBufferForEvent

- clearReplayBufferForEvent(eventName: string): void

- - Defined in noel.ts:123

  #### Parameters

  - ##### eventName: string

  #### Returns void

### Private disableEventsReplay

- disableEventsReplay(): void

- - Defined in noel.ts:178

  #### Returns void

### disableNoEventListenersWarning

- disableNoEventListenersWarning(): void

- - Defined in noel.ts:82

  #### Returns void

### disableReplay

- disableReplay(): void

- - Defined in noel.ts:102

  #### Returns void

### emit

- emit(eventName: string, ...eventArgs: Array<any>): void

- - Defined in noel.ts:37

  #### Parameters

  - ##### eventName: string

  - ##### Rest ...eventArgs: Array<any>

  #### Returns void

### Private enableEventsReplay

- enableEventsReplay(): void

- - Defined in noel.ts:188

  #### Returns void

### enableNoEventListenersWarning

- enableNoEventListenersWarning(): void

- - Defined in noel.ts:72

  #### Returns void

### enableReplay

- enableReplay(): void

- - Defined in noel.ts:96

  #### Returns void

### getEvent

- getEvent(eventName: string): NoelEvent

- - Defined in noel.ts:132

  #### Parameters

  - ##### eventName: string

  #### Returns NoelEvent

### Private getEvents

- getEvents(): IterableIterator<NoelEvent>

- - Defined in noel.ts:198

  #### Returns IterableIterator<NoelEvent>

### Private getEventsMap

- getEventsMap(): Map<string, NoelEvent>

- - Defined in noel.ts:203

  #### Returns Map<string, NoelEvent>

### Private makeEvent

- makeEvent(eventName: string): NoelEvent

- - Defined in noel.ts:157

  #### Parameters

  - ##### eventName: string

  #### Returns NoelEvent

### on

- on(eventName: string, listener: NoelEventListener): NoelEventListenerManager

- - Defined in noel.ts:42

  #### Parameters

  - ##### eventName: string

  - ##### listener: NoelEventListener

  #### Returns NoelEventListenerManager

### removeAllListeners

- removeAllListeners(eventName: string): void

- - Defined in noel.ts:149

  #### Parameters

  - ##### eventName: string

  #### Returns void

### removeEvent

- removeEvent(eventName: string): void

- - Defined in noel.ts:142

  #### Parameters

  - ##### eventName: string

  #### Returns void

### removeEventListener

- removeEventListener(event: NoelEvent, listener: NoelEventListener): void

- - Defined in noel.ts:57

  #### Parameters

  - ##### event: NoelEvent

  - ##### listener: NoelEventListener

  #### Returns void

### removeListener

- removeListener(eventName: string, listener: NoelEventListener): void

- - Defined in noel.ts:47

  #### Parameters

  - ##### eventName: string

  - ##### listener: NoelEventListener

  #### Returns void

### replayIsEnabled

- replayIsEnabled(): boolean

- - Defined in noel.ts:92

  #### Returns boolean

### Private setEventsReplayBuffersSize

- setEventsReplayBuffersSize(replayBuffersSize: number): void

- - Defined in noel.ts:168

  #### Parameters

  - ##### replayBuffersSize: number

  #### Returns void

### setLogger

- setLogger(logger: NoelLogger): void

- - Defined in noel.ts:63

  #### Parameters

  - ##### logger: NoelLogger

  #### Returns void

### setReplayBufferSize

- setReplayBufferSize(replayBufferSize: number): void

- - Defined in noel.ts:108

  #### Parameters

  - ##### replayBufferSize: number

  #### Returns void

Generated using TypeDoc